package cn.net.caoyao.cpzshandset.service.thread.impl.liqueur;

import java.io.IOException;
import java.net.BindException;
import java.net.ConnectException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;

import android.os.Handler;
import android.os.Message;
import cn.net.caoyao.cpzshandset.bean.ActivateBean;
import cn.net.caoyao.cpzshandset.bean.SingleLabelOptionBean;
import cn.net.caoyao.cpzshandset.bean.UploadBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.InternalOptionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.service.bll.ActivateBll;
import cn.net.caoyao.cpzshandset.service.bll.BatchLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.SingleLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20017ReqBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20033ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20017LabelBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20017CheckLabelStatus;
import cn.net.cpzslibs.prot.handset.newProt.Prot20033Activate;

public class LiqueurSubmitAllActivateThread implements Runnable {
	private long deviceId;
	private ActivateBll bll;
	private SingleLabelBll labelBll;
	private BatchLabelBll batchBll;
	private UploadStatusBll uploadStatusBll;
	private List<ActivateBean> aBeans;
	private Handler mHandler;
	private int option_type = HandsetOperation.OPERATION_ACTIVATE_CONSTANT.getOption();

	public LiqueurSubmitAllActivateThread(Handler mHandler,long deviceId,ActivateBll bll,SingleLabelBll labelBll,BatchLabelBll batchBll,UploadStatusBll uploadStatusBll,List<ActivateBean> aBeans) {
		this.mHandler = mHandler;
		this.deviceId = deviceId;
		this.bll = bll;
		this.labelBll = labelBll;
		this.batchBll = batchBll;
		this.uploadStatusBll = uploadStatusBll;
		this.aBeans = aBeans;
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, "");
		try {
//			LogUtil.d(TConfig.Echo, "登录");
			create.createLoginCpzsHandset(deviceId);
			if (create.isResult()) {
				submitActivateInfo(create);
			} else {
				Message msg = new Message();
				msg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				msg.arg1 = create.getiErrCode();
				msg.obj = create.getErrMsg();
				mHandler.sendMessage(msg);
			}
			
		} catch (BindException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (ConnectException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (UnknownHostException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		}finally {
			new Prot02Logout().dealLogout(create);
		}
	}

	private void submitActivateInfo(SocketCreate create) throws IOException,SocketTimeoutException{
		for (ActivateBean activateBean : aBeans) {
			if (activateBean.getOption_mode() == Config.SINGLE_OPTION_LABEL_TYPE) {
				//单标
				submitSingleActivateInfo(create,activateBean);
			} else if (activateBean.getOption_mode() == Config.BATCH_OPTION_LABEL_TYPE) {
				//批量
				submitBatchActivateInfo(create,activateBean);
			}
		}
		mHandler.sendEmptyMessage(RequestConstant.SUBMIT_ALL_ACTIVATE_COMPLETE);
	}
	private void submitBatchActivateInfo(SocketCreate create, ActivateBean activateBean) throws IOException{
		int count = batchBll.queryBatchCountById(option_type, activateBean.getId());
		if (count > 0) {
			Prot20033Activate activate = new Prot20033Activate();
			activate.submitActivateInfo(create, getBatchReqBean(activateBean));
			ProtStatusResBean resBean = activate.getResBean();
			if (resBean == null) {
				return;
			}
			if (resBean.getResult() == 0) {
				//上传成功，插入记录到提交状态表
				uploadStatusBll.insertUploadStatus(getUploadBean(activateBean));
				bll.delActivateById(activateBean);
			} else {
				bll.updateActivateErrorById(resBean.getErrcode(), activateBean.getId());
			}
			
		}
		
	}

	private UploadBean getUploadBean(ActivateBean activateBean) {
		UploadBean b = new UploadBean();
		if (activateBean.getOption_mode() == Config.SINGLE_OPTION_LABEL_TYPE) {
			b.setLabel_count(labelBll.queryLabelCountById(option_type, activateBean.getId()));
		} else {
			b.setLabel_count(batchBll.queryBatchCountById(option_type, activateBean.getId()));
		}
		b.setOption_type(option_type);
		return b;
	}

	private Prot20033ReqBean getBatchReqBean(ActivateBean activateBean) {
		Prot20033ReqBean reqBean = new Prot20033ReqBean();
		reqBean.setProduct_id(activateBean.getProduct_id());
		reqBean.setProduce_date(activateBean.getProduct_date());
		reqBean.setProduce_batch(activateBean.getProduct_batch_number());
		reqBean.setTeam(String.valueOf(activateBean.getGroup_number_id()));
		reqBean.setType(Config.BATCH_OPTION_LABEL_TYPE);
		reqBean.setBatcher(batchBll.queryBatchBeanById(option_type, activateBean.getId()));
		return reqBean;
	}

	private void submitSingleActivateInfo(SocketCreate create,ActivateBean activateBean) throws IOException{
		int count = labelBll.queryLabelCountById(option_type, activateBean.getId());
		if (count > 0) {
			Prot20033Activate activate = new Prot20033Activate();
			activate.submitActivateInfo(create, getSingleReqBean(activateBean));
			ProtStatusResBean resBean = activate.getResBean();
			if (resBean == null) {
				return;
			}
			if (resBean.getResult() == 0) {
				uploadStatusBll.insertUploadStatus(getUploadBean(activateBean));
//				LogUtil.i(TConfig.Echo, "插入单标激活提交状态：" + getUploadBean(activateBean).toString());
				bll.delActivateById(activateBean);
//				bll.delActivateById(activateBean.getId());
//				labelBll.deleteLabelById(option_type, activateBean.getId());
			} else {
				bll.updateActivateErrorById(resBean.getErrcode(), activateBean.getId());
				checkLabel(create,activateBean);
			}
		}
		
	}

	private void checkLabel(SocketCreate create,ActivateBean activateBean) throws IOException{
		Prot20017CheckLabelStatus prot20017 = new Prot20017CheckLabelStatus();
		prot20017.checkLabel(create, getProt20017ReqBean(activateBean));
		if (prot20017.getResBean() != null && prot20017.getResBean().getResult() == 0) {
			List<Prot20017LabelBean> invilad = prot20017.getResBean().getLabel_invalid();
			if (invilad != null) {
				List<String> inviladLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : invilad) {
					inviladLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(inviladLabel, option_type, activateBean.getId(), InternalOptionConstant.SINGLE_LABEL_STATUS_INVALID);
			}
			
			List<Prot20017LabelBean> repeat = prot20017.getResBean().getLabel_double_active();
			if (repeat != null) {
				List<String> repeatLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : repeat) {
					repeatLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(repeatLabel, option_type, activateBean.getId(), InternalOptionConstant.SINGLE_LABEL_STATUS_REPEAT_ACTIVATE);
			}
		}
		
	}

	private Prot20017ReqBean getProt20017ReqBean(ActivateBean activateBean) {
		Prot20017ReqBean reqBean = new Prot20017ReqBean();
		reqBean.setLabels(getLabels(activateBean.getId()));
		reqBean.setOpt(8);
		return reqBean;
	}

	private Prot20033ReqBean getSingleReqBean(ActivateBean activateBean) {
		Prot20033ReqBean reqBean = new Prot20033ReqBean();
		reqBean.setProduct_id(activateBean.getProduct_id());
		reqBean.setProduce_date(activateBean.getProduct_date());
		reqBean.setProduce_batch(activateBean.getProduct_batch_number());
		reqBean.setTeam(String.valueOf(activateBean.getGroup_number_id()));
		reqBean.setType(Config.SINGLE_OPTION_LABEL_TYPE);
		reqBean.setSingle(getLabels(activateBean.getId()));
//		LogUtil.i(TConfig.Echo, "提交的数据：" + reqBean.toString());
		return reqBean;
	}

	private List<String> getLabels(int id) {
		List<String> singles = new ArrayList<>();
		List<SingleLabelOptionBean> singleOptions = labelBll.queryAllLabelById(option_type, id);
		for (SingleLabelOptionBean sLBean : singleOptions) {
			singles.add(sLBean.getLabel_id());
		}
		return singles;
	}


}
